CON
  _clkmode = xtal1 + pll16x     
  _xinfreq = 5_000_000

  BUFFER_2K     = $800
  
  CR            = $0D
  LF            = $0A
  NULL          = $00

  SOCKETS       = 8
  
  #0, CLOSED, TCP, UDP, IPRAW, MACRAW, PPPOE

    
  SHT_CLK         = 19                   { TEMP/ RV sensor}
  SHT_DATA        = 20                   { TEMP/ RV sensor}

  Zero_Out = 0                  {valvue to reset historic reading}

  i2cSCL        = 28   
  EEPROMAddr    = %1010_0000
    
VAR
  long  seed
  long stack1[128]

  byte templock,notactive

  byte  temp[32]                               {input temp }
  byte  lv[32]                                 {input lv }
  long tempC,tempC1,tempC2,tempC3              {global temp vars }
  long lv1,lv2,lv3                             {global lv vars }

  long tempmax,tempmin       {Historis Min /Max Temp Variabelen }
  long lvmax,lvmin ,eepromData          {Historis Min /Max LV Variabelen } 
DAT
  index byte  "HTTP/1.1 200 OK", CR, LF, {
}             "Content-Type: text/html", CR, LF, CR, LF, {
}             "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>", CR, LF, {
}             "<html  xmlns='http://www.w3.org/1999/xhtml'>" , CR, LF, {
}             "<head><meta http-equiv='Content-Type' content='text/html; charset=utf-8' />", CR, LF, {

}             "<meta name='viewport' content='width=device-width, initial-scale=1, maximum-scale=1'>", CR, LF, { 
}             "<meta name='description' content='An ICE Control Production.' >", CR, LF, { 
}             "<title>ICE Control</title>", CR, LF, {

}             "<link rel='stylesheet' href='http://chrisvalleskey.com/wp-content/themes/unique/css/style.css' type='text/css' media='screen' />", CR, LF, { 
}             "<link rel='stylesheet' href='http://chrisvalleskey.com/wp-content/themes/unique/css/custom/graph-style.css' type='text/css' media='screen' />", CR, LF, {

}             "<script type='text/javascript' src='http://192.168.2.151/test/graph.js'></script>", CR, LF, {
}             "<script type='text/javascript'>" , CR, LF, {

}             "window.onload = function() {", CR, LF, {
}             "g_graph = new Graph({", CR, LF, {
}             "'id': 'firstgraph',", CR, LF, {
}             "'strokeStyle': '#819C58',", CR, LF, {
}             "'fillStyle': 'rgba(64,128,0,0.25)',", CR, LF, {
}             "'call': function(){ return ( Math.floor(latestTemp())); }", CR, LF, {
}             "});", CR, LF, {

}             "g_graph2 = new Graph({", CR, LF, {
}             "'id': 'secondgraph',", CR, LF, {
}             "'strokeStyle': '#819C58',", CR, LF, {
}             "'fillStyle': 'rgba(64,128,0,0.25)',", CR, LF, {
}             "'call': function(){ return ( Math.floor(latestHumidity())); }", CR, LF, {
}             "});}", CR, LF, {

}             "</script>", CR, LF, {

}             "<script type='text/javascript'>", CR, LF, {
}             "setInterval(", $22, "getRequest('xmltemp', 'placeholder')", $22, ", 1000);", CR, LF, {



}             "</script>", CR, LF, {
}             "</head>", CR, LF, {

}             "<body id='graph' class='page'>", CR, LF, {
}             "<header id='top-bar' class='bar'>", CR, LF, { 
}             "<h1><a href='http://192.168.2.151'>ICE Control</a></h1>", CR, LF, {

}             "</header>", CR, LF, { 
}             "<article id='post' role='main'>", CR, LF, {
}             "<div class='container'>", CR, LF, {
}             "<header>", CR, LF, {
}             "<hgroup>", CR, LF, {
}             "<h1>Temperatuur</h1>", CR, LF, {    
}             "</hgroup>", CR, LF, {
}             "</header>", CR, LF, {   
}             "<section class=post-content'>", CR, LF, {  

}             "<body>", CR, LF, {
}             "<div><span id='placeholder'>10.0</span></div>", CR, LF, {
}             "<div><canvas id='firstgraph' width='940' height='200'></canvas><p class='buttons'>", CR, LF, {   
}             "<a onclick=", $22, "toggleValue('showgrid')", $22, "class='btn'>Grid</a>", CR, LF, {  
}             "<a onclick=", $22, "toggleValue('showshadow')", $22, "class='btn'>Shadow</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showline')", $22, "class='btn'>Lines</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showfill')", $22, "class='btn'>Fill</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showdots')", $22, "class='btn'>Dots</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showlabels')", $22, "class='btn'>Labels</a>", CR, LF, {

}             "<a onclick='setFill()' class='btn'>Random Fill</a>", CR, LF, {
}             "<a onclick='setColor()' class='btn'>Random Color</a>", CR, LF, {
}             "<a onclick='clearGraph()' class='btn right'>Clear Graph</a>", CR, LF, {
}             "<a onclick='toggleDraw()' class='btn right'>Toggle Draw</a> ", CR, LF, {    
}             "</p>", CR, LF, {

}             "</div>", CR, LF, {   
}             "</header>", CR, LF, { 

}             "<div class='container'>", CR, LF, {
}             "<header>", CR, LF, {
}             "<hgroup>", CR, LF, {
}             "<h1>Vochtigheid</h1>", CR, LF, {    
}             "</hgroup>", CR, LF, {
}             "</header>", CR, LF, {   
}             "<section class=post-content'>", CR, LF, {  



}             "<div><span id='placeholder2'>5.0</span></div>", CR, LF, { 
}             "<div><canvas id='secondgraph' width='940' height='200'></canvas><p class='buttons'>", CR, LF, {      

}             "<a onclick=", $22, "toggleValue('showgrid')", $22, "class='btn'>Grid</a>", CR, LF, {  
}             "<a onclick=", $22, "toggleValue('showshadow')", $22, "class='btn'>Shadow</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showline')", $22, "class='btn'>Lines</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showfill')", $22, "class='btn'>Fill</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showdots')", $22, "class='btn'>Dots</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showlabels')", $22, "class='btn'>Labels</a>", CR, LF, {

}             "<a onclick='setFill()' class='btn'>Random Fill</a>", CR, LF, {
}             "<a onclick='setColor()' class='btn'>Random Color</a>", CR, LF, {
}             "<a onclick='clearGraph()' class='btn right'>Clear Graph</a>", CR, LF, {
}             "<a onclick='toggleDraw()' class='btn right'>Toggle Draw</a> ", CR, LF, {    
}             "</p>", CR, LF, {

}             "</div>", CR, LF, {  

}             "<script type='text/javascript'>" , CR, LF, { 
}             "function toggleDraw() { g_graph.toggleDraw(); }", CR, LF, {
}             "function toggleValue(value) { g_graph.toggleValue(value); }", CR, LF, {
}             "function setFill(val) { if(val == undefined) val = getRandomRGBA(); g_graph.setValue('fillStyle',val); }", CR, LF, {
}             "function setColor(val) { if(val == undefined) val = getRandomRGB(); g_graph.setValue('strokeStyle',val); }", CR, LF, {
}             "function getRandomRGB() { return 'rgb(' + Math.floor(Math.random()*255)  + ', ' + Math.floor(Math.random()*255) + ', ' + Math.floor(Math.random()*255) + ')'; }", CR, LF, {
}             "function getRandomRGBA() { return 'rgba(' + Math.floor(Math.random()*255)  + ', ' + Math.floor(Math.random()*255) + ', ' + Math.floor(Math.random()*255) + ', ' + '0.25)'; }", CR, LF, {
}             "function clearGraph() { g_graph.clearGraph(); }", CR, LF, {
}             "</script>", CR, LF, {   




}             "</body>", CR, LF, {
}             "</html>", 0



  xml   byte  "HTTP/1.1 200 OK", CR, LF, {
  }           "Content-Type: text/xml", CR, LF, CR, LF, {
  }           "<?xml version='1.0' encoding='utf-8'?><root><temp>"
  temperature  byte  $30, $30, $2E, $30, "</temp><humidity>"
  lvlv     byte  $30, $30, $2E, $30, "</humidity></root>", 0
  
  buff  byte  $0[BUFFER_2K]


OBJ
  pst             : "Parallax Serial Terminal"
  wiz             : "W5200.spin" 
  sock[SOCKETS] : "Socket.spin"
  sht           : "Sensirion_full"         { temp/lv sensor control object }
  fp            : "FloatString"              { Math object }
  f             : "Float32"                  { Math object }
  i2cObject     : "basic_i2c_driver"         {Eprom object}  
PUB Main | i, page
  
  cognew(tempcontrol,@stack1)
  
  pst.Start(115_200)
  pause(500)

  wiz.Init 
  wiz.SetIp(192, 168, 2, 200)
  wiz.SetMac($00, $08, $DC, $16, $F8, $01)

  repeat
    pst.str(string("Initialize Sockets",CR))
    repeat i from 0 to SOCKETS-1
      sock[i].Init(i, TCP, 8080)
           
    OpenListeners
    StartListners
        
    pst.str(string("Start Socket server",CR))
    \MultiSocketServer
    pst.str(string("I blew up!"))
    pause(5000)


  
PUB OpenListeners | i
  pst.str(string("Open",CR))
  repeat i from 0 to SOCKETS-1  
    sock[i].Open
      
PUB StartListners | i
  repeat i from 0 to SOCKETS-1
    if(sock[i].Listen)
      pst.str(string("Listen "))
    else
      pst.str(string("Listener failed ",CR))
    pst.dec(i)
    pst.char(CR)

PUB CloseWait | i
  repeat i from 0 to SOCKETS-1
   
    if(sock[i].IsCloseWait) 
      sock[i].Disconnect
      sock[i].Close
      
    if(sock[i].IsClosed)  
      sock[i].Open
      sock[i].Listen

PUB MultiSocketServer | bytesToRead, i, page, j, x , bytesSent, ptr
  bytesToRead := bytesSent := i := j := x := 0
  repeat
    pst.str(string("TCP Service", CR))
    CloseWait

    repeat j from 0 to SOCKETS-1
      pst.str(string("Socket "))
      pst.dec(j)
      pst.str(string(" = "))
      pst.hex(wiz.GetSocketStatus(j), 2)
      pst.char(13)
     
    repeat until sock[i].Connected
      i := ++i // SOCKETS

    pst.str(string("Connected Socket "))
    pst.dec(i)
    pst.char(CR)
    
    'Data in the buffer?
    repeat until bytesToRead := sock[i].Available

    'Check for a timeout
    if(bytesToRead < 0)
      pst.str(string("Timeout",CR))
      sock[i].Disconnect
      sock[i].Open
      sock[i].Listen
      bytesToRead~
      next

    pst.str(string("Copy Rx Data",CR))
  
    'Get the Rx buffer  
    sock[i].Receive(@buff, bytesToRead)

    {{ Process the Rx data}}
    pst.char(CR)
    pst.str(string("Request:",CR))
    'pst.str(@buff)

    pst.str(string("Send Response",CR))
    page :=  ParseResource(@buff)
    
    pst.str(page)
    pst.char(CR)
    pst.str(string("Byte to send "))
    pst.dec(strsize(page))
    pst.char(CR)

    bytesSent := 0
    ptr := page
    repeat until bytesSent == strsize(page)
      bytesSent += sock[i].Send(ptr, strsize(ptr))
      ptr := page + bytesSent

    pst.str(string("Bytes Sent "))
    pst.dec(bytesSent)
    pst.char(CR)

    pst.str(string("Disconnect socket "))
    pst.dec(i)
    pst.char(CR)

    if(sock[i].Disconnect)
      pst.str(string("Disconnected", CR))
    else
      pst.str(string("Force Close", CR))
    sock[i].Open
    sock[i].Listen
    sock[i].SetSocketIR($FF)
    
    i := ++i // SOCKETS
    bytesToRead~
    

PUB ParseResource(header) | ptr, value
  ptr := header
  repeat until byte[ptr++] == $2F '/ forward slash
  if(byte[ptr] == $20) ' space
    return @index
  else
    value := GetTemp
    SetTemp(tempc3)
    Setlv(lv3)
    return @xml


PUB GetTemp
  seed := CNT 
  ?seed
  return seed & $0F + 1
  
PUB SetTemp(value) | t1
  t1 := value
  t1 := t1/100
  value -= t1 * 100
  if(t1 > 0 and t1 < 9)
    byte[@temperature][0] := t1 + $30
  else
    ResetTemp
    return 

  t1 := value
  t1 := t1/10
  value -= t1 * 10
  if(t1 > 0 and t1 < 9) 
    byte[@temperature][1] := t1 + $30
  else
    ResetTemp
    return
    
  t1 := value
  if(t1 > 0 and t1 < 9)  
    byte[@temperature][3] := t1 + $30
  else
    ResetTemp
    return
    
PUB SetLV(value) | t1                                              
  t1 := value
 

  t1 := value
  t1 := t1/10
  value -= t1 * 10
  'if(t1 > 0 and t1 < 9) 
    byte[@lvlv][0] := t1 + $30
  'else
    'ResetTemp
    'return
    
  t1 := value
  'if(t1 > 0 and t1 < 9)  
    byte[@lvlv][1] := t1 + $30
  'else
    'ResetTemp
    'return
  
  
PUB ResetTemp
  byte[12] := $30
  byte[13] := $30
  byte[14] := $30  
     



     
PUB PrintIp(addr) | i
  repeat i from 0 to 3
    pst.dec(byte[addr][i])
    if(i < 3)
      pst.char($2E)
    else
      pst.char($0D)
  
PRI pause(Duration)  
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)
  return

PUB Tempcontrol

    
    templock:=locknew
  
    
    sht.start(SHT_DATA,SHT_CLK)
    f.start
    
    lvmax := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6997)
    lvmin := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6993)
    tempmax := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6989)
    tempmin := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6985)
    
  repeat 
    repeat until not lockset(templock)    
      sht.config(33,sht#off,sht#yes,sht#hires)
      tempC := celsius(f.FFloat(sht.readHumidity))
      tempC1 := F.FMul(celsius(f.FFloat(sht.readTemperature)),10.0)     {floating point raw measurement temp}
    
      bytemove(@Temp, tempC2, strsize(tempC2) +1)      { copy string }
      tempC3 :=f.FTrunc(tempC1)                              { integer to calculate/use  }
      
     
      lv1 := humidityy(tempC, f.FFloat(sht.readHumidity))   {floating poitn ram measurement RH }
      
      bytemove(@Lv, lv2, strsize(lv2) +1)            { copy string }
      lv3 :=f.FTrunc(lv1)
      lockclr(templock)
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''  

    if tempmin == 0                                    '' max/ min temp geheugen ''
        if tempC3 < 999 and tempC3 > 0                   { remove faulty readings from getting stored in history "boundaries"} 
           tempmin:=tempC3
                 
    if tempC3 > tempmax
        if tempC3 < 999 and tempC3 > 0                   { remove faulty readings from getting stored in history "boundaries" }
          tempmax := tempC3
          i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6989, tempC3)
           
    if tempC3 < tempmin
       if tempC3 < 999 and tempC3 > 0                   { remove faulty readings from getting stored in history "boundaries"} 
         tempmin := tempC3   
         i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6985, tempC3)

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    if lvmin == 0                                    '' max/ min lv geheugen ''
       if lv3 < 99 and lv3 > 10                   { remove faulty readings from getting stored in history boundaries } 
           lvmin:=lv3
                 
    if lv3 > lvmax
       if lv3 < 99 and lv3 > 10                   { remove faulty readings from getting stored in history boundaries }
          lvmax := lv3                                 
          i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6997, lv3)
                     
    if lv3 < lvmin
       if lv3 < 99 and lv3 > 10                   { remove faulty readings from getting stored in history boundaries }  
          lvmin := lv3   
          i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6993, lv3) 
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''           
    waitcnt(clkfreq + cnt)

PUB celsius(t)
  ' from SHT1x/SHT7x datasheet using value for 3.5V supply
  ' celsius = -39.7 + (0.01 * t)
  return f.FAdd(-39.7, f.FMul(0.01, t))  
  
PUB humidityy(t, rhh) | rhLinear
  ' rhLinear = -2.0468 + (0.0367 * rh) + (-1.5955E-6 * rh * rh)
  ' simplifies to: rhLinear = ((-1.5955E-6 * rh) + 0.0367) * rh -2.0468
  rhLinear := f.FAdd(f.FMul(f.FAdd(0.0367, f.FMul(-1.5955E-6, rhh)), rhh), -2.0468)
  ' rhTrue = (t - 25.0) * (0.01 + 0.00008 * rawRH) + rhLinear
  return f.FAdd(f.FMul(f.FSub(t, 25.0), f.FAdd(0.01, f.FMul(0.00008, rhh))), rhLinear)      